diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index a6ae82946..247764890 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -3,12 +3,12 @@ package net.minecraft.core.entity;
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.ints.Int2ObjectMaps;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
-import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.entity.animal.*;
+import net.minecraft.core.entity.factories.EntityDontUseFactory;
+import net.minecraft.core.entity.factories.EntityFactory;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.*;
@@ -21,89 +21,160 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
+import java.util.ArrayList;
 import java.util.HashMap;
+import java.util.List;
 import java.util.Map;
 
 public final class EntityDispatcher
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-    private static int mappingCount = 0;
+    private static final @NotNull EntityDispatcher INSTANCE = new EntityDispatcher();
 
-    public static final Map<Class<? extends Entity>, NamespaceID> classToIdMap = new HashMap<>();
-    public static final Map<NamespaceID, Class<? extends Entity>> idToClassMap = new HashMap<>();
-    public static final Map<String, Class<? extends Entity>> stringIdToClassMap = new HashMap<>();
-
-    private static final Int2ObjectMap<Class<? extends Entity>> numericIdToClassMap = new Int2ObjectOpenHashMap<>();
-    private static final Int2ObjectMap<String> numericIdToStringIdMap = new Int2ObjectOpenHashMap<>();
-    private static final Object2IntMap<Class<? extends Entity>> classToNumericIdMap = new Object2IntOpenHashMap<>();
-
-    private static final Map<Class<? extends Entity>, String> classToNameKeyMap = new HashMap<>();
-
-    private EntityDispatcher() {}
-
-    public static void addMapping(@NotNull Class<? extends Entity> entityClass, @NotNull NamespaceID namespaceID) {
-        addMapping(entityClass, namespaceID, null);
+    public static @NotNull EntityDispatcher getInstance() {
+        return INSTANCE;
     }
 
-    public static void addMapping(@NotNull Class<? extends Entity> entityClass, @NotNull NamespaceID namespaceID, @Nullable String nameKey) {
-        if (classToIdMap.containsKey(entityClass)) {
-            throw new IllegalArgumentException("EntityDispatcher already contains an assignment for class " + entityClass.getSimpleName() + " with namespace " + classToIdMap.get(entityClass) + "!");
-        }
-        final @NotNull NamespaceID unpooledNamespaceID = namespaceID.copyUnpooled();
-
-        classToIdMap.put(entityClass, unpooledNamespaceID);
-        idToClassMap.put(unpooledNamespaceID, entityClass);
-        stringIdToClassMap.put(unpooledNamespaceID.toString(), entityClass);
-
-        int numericId = mappingCount++;
-        numericIdToClassMap.put(numericId, entityClass);
-        numericIdToStringIdMap.put(numericId, unpooledNamespaceID.toString());
-        classToNumericIdMap.put(entityClass, numericId);
-
-        if (nameKey != null) {
-            classToNameKeyMap.put(entityClass, nameKey);
-        }
-    }
+    private int mappingCount = 0;
+
+    public final List<@NotNull EntityDispatcherEntry<?>> entries = new ArrayList<>();
+    public final Map<@NotNull NamespaceID, @NotNull EntityDispatcherEntry<?>> idToEntryMap = new HashMap<>();
+    public final Map<@NotNull String, @NotNull EntityDispatcherEntry<?>> stringIdToEntryMap = new HashMap<>();
+    public final Map<@NotNull Class<?>, @NotNull EntityDispatcherEntry<?>> classToEntryMap = new HashMap<>();
+    private final Int2ObjectMap<@NotNull EntityDispatcherEntry<?>> numericIdToEntryMap = new Int2ObjectOpenHashMap<>();
+    private final Int2ObjectMap<@NotNull String> numericIdToStringIdMap = new Int2ObjectOpenHashMap<>();
+
+    // Misc
+    public final EntityFactory<EntityItem> FACTORY_ITEM;
+    public final EntityFactory<EntityPainting> FACTORY_PAINTING;
+    public final EntityFactory<EntityLightning> FACTORY_LIGHTNING;
+    public final EntityFactory<EntityFallingBlock> FACTORY_FALLING_BLOCK;
+    public final EntityFactory<EntityMinecart> FACTORY_MINECART;
+    public final EntityFactory<EntityBoat> FACTORY_BOAT;
+    public final EntityFactory<EntityPrimedTNT> FACTORY_PRIMED_TNT;
+
+    // Projectiles
+    public final EntityFactory<ProjectilePebble> FACTORY_PROJECTILE_PEBBLE;
+    public final EntityFactory<ProjectileEgg> FACTORY_PROJECTILE_EGG;
+    public final EntityFactory<ProjectileArrow> FACTORY_PROJECTILE_ARROW;
+    public final EntityFactory<ProjectileArrowGolden> FACTORY_PROJECTILE_ARROW_GOLDEN;
+    public final EntityFactory<ProjectileArrowPurple> FACTORY_PROJECTILE_ARROW_PURPLE;
+    public final EntityFactory<ProjectileSnowball> FACTORY_PROJECTILE_SNOWBALL;
+    public final EntityFactory<ProjectileFireball> FACTORY_PROJECTILE_FIREBALL;
+    public final EntityFactory<ProjectileCannonball> FACTORY_PROJECTILE_CANNONBALL;
+
+    public final EntityFactory<Mob> FACTORY_MOB;
+    public final EntityFactory<MobHuman> FACTORY_HUMAN;
+    public final EntityFactory<Player> FACTORY_PLAYER;
+
+    // Hostile
+    public final EntityFactory<MobZombie> FACTORY_ZOMBIE;
+    public final EntityFactory<MobZombieArmored> FACTORY_ZOMBIE_ARMORED;
+    public final EntityFactory<MobZombiePig> FACTORY_ZOMBIE_PIG;
+    public final EntityFactory<MobCreeper> FACTORY_CREEPER;
+    public final EntityFactory<MobSkeleton> FACTORY_SKELETON;
+    public final EntityFactory<MobSpider> FACTORY_SPIDER;
+    public final EntityFactory<MobGiant> FACTORY_GIANT;
+    public final EntityFactory<MobSlime> FACTORY_SLIME;
+    public final EntityFactory<MobGhast> FACTORY_GHAST;
+    public final EntityFactory<MobSnowman> FACTORY_SNOWMAN;
+
+    // Passive
+    public final EntityFactory<MobScorpion> FACTORY_SCORPION;
+    public final EntityFactory<MobPig> FACTORY_PIG;
+    public final EntityFactory<MobSheep> FACTORY_SHEEP;
+    public final EntityFactory<MobCow> FACTORY_COW;
+    public final EntityFactory<MobChicken> FACTORY_CHICKEN;
+    public final EntityFactory<MobSquid> FACTORY_SQUID;
+    public final EntityFactory<MobWolf> FACTORY_WOLF;
+    public final EntityFactory<MobFireflyCluster> FACTORY_FIREFLY_CLUSTER;
+    public final EntityFactory<MobButterfly> FACTORY_BUTTERFLY;
+    public final EntityFactory<MobDeer> FACTORY_DEER;
+
+    private EntityDispatcher() {
+        // Misc
+        FACTORY_ITEM = addMapping(EntityItem.class, NamespaceID.fromPool("minecraft", "item"), EntityItem::new);
+        FACTORY_PAINTING = addMapping(EntityPainting.class, NamespaceID.fromPool("minecraft", "painting"), EntityPainting::new);
+        FACTORY_LIGHTNING = addMapping(EntityLightning.class, NamespaceID.fromPool("minecraft", "lightning"), EntityLightning::new);
+        FACTORY_FALLING_BLOCK = addMapping(EntityFallingBlock.class, NamespaceID.fromPool("minecraft", "falling_block"), EntityFallingBlock::new);
+        FACTORY_MINECART = addMapping(EntityMinecart.class, NamespaceID.fromPool("minecraft", "minecart"), EntityMinecart::new);
+        FACTORY_BOAT = addMapping(EntityBoat.class, NamespaceID.fromPool("minecraft", "boat"), EntityBoat::new);
+        FACTORY_PRIMED_TNT = addMapping(EntityPrimedTNT.class, NamespaceID.fromPool("minecraft", "primed_tnt"), EntityPrimedTNT::new);
 
-    public static @Nullable Class<? extends Entity> classForId(@NotNull NamespaceID id) {
-        return idToClassMap.get(id);
-    }
+        // Projectiles
+        FACTORY_PROJECTILE_PEBBLE = addMapping(ProjectilePebble.class, NamespaceID.fromPool("minecraft", "pebble"), ProjectilePebble::new);
+        FACTORY_PROJECTILE_EGG = addMapping(ProjectileEgg.class, NamespaceID.fromPool("minecraft", "egg"), ProjectileEgg::new);
+        FACTORY_PROJECTILE_ARROW = addMapping(ProjectileArrow.class, NamespaceID.fromPool("minecraft", "arrow"), ProjectileArrow::new);
+        FACTORY_PROJECTILE_ARROW_GOLDEN = addMapping(ProjectileArrowGolden.class, NamespaceID.fromPool("minecraft", "arrow_golden"), ProjectileArrowGolden::new);
+        FACTORY_PROJECTILE_ARROW_PURPLE = addMapping(ProjectileArrowPurple.class, NamespaceID.fromPool("minecraft", "arrow_purple"), ProjectileArrowPurple::new);
+        FACTORY_PROJECTILE_SNOWBALL = addMapping(ProjectileSnowball.class, NamespaceID.fromPool("minecraft", "snowball"), ProjectileSnowball::new);
+        FACTORY_PROJECTILE_FIREBALL = addMapping(ProjectileFireball.class, NamespaceID.fromPool("minecraft", "fireball"), ProjectileFireball::new);
+        FACTORY_PROJECTILE_CANNONBALL = addMapping(ProjectileCannonball.class, NamespaceID.fromPool("minecraft", "cannonball"), ProjectileCannonball::new);
+
+        FACTORY_MOB = addMapping(Mob.class, NamespaceID.fromPool("minecraft", "mob"), new EntityDontUseFactory<>()); // Abstract class, shouldn't ever be instantiated
+        FACTORY_HUMAN = addMapping(MobHuman.class, NamespaceID.fromPool("minecraft", "human"), MobHuman::new);
+        FACTORY_PLAYER = addMapping(Player.class, NamespaceID.fromPool("minecraft", "player"), new EntityDontUseFactory<>());
 
-    public static @Nullable Class<? extends Entity> classForId(@NotNull String id) {
-        return stringIdToClassMap.get(id);
-    }
+        // Hostile
+        FACTORY_ZOMBIE = addMapping(MobZombie.class, NamespaceID.fromPool("minecraft", "zombie"), MobZombie::new, "guidebook.section.mob.zombie.name");
+        FACTORY_ZOMBIE_ARMORED = addMapping(MobZombieArmored.class, NamespaceID.fromPool("minecraft", "zombie_armored"), MobZombieArmored::new, "guidebook.section.mob.armored_zombie.name");
+        FACTORY_ZOMBIE_PIG = addMapping(MobZombiePig.class, NamespaceID.fromPool("minecraft", "zombie_pigman"), MobZombiePig::new, "guidebook.section.mob.zombie_pigman.name");
+        FACTORY_CREEPER = addMapping(MobCreeper.class, NamespaceID.fromPool("minecraft", "creeper"), MobCreeper::new, "guidebook.section.mob.creeper.name");
+        FACTORY_SKELETON = addMapping(MobSkeleton.class, NamespaceID.fromPool("minecraft", "skeleton"), MobSkeleton::new, "guidebook.section.mob.skeleton.name");
+        FACTORY_SPIDER = addMapping(MobSpider.class, NamespaceID.fromPool("minecraft", "spider"), MobSpider::new, "guidebook.section.mob.spider.name");
+        FACTORY_GIANT = addMapping(MobGiant.class, NamespaceID.fromPool("minecraft", "giant"), MobGiant::new);
+        FACTORY_SLIME = addMapping(MobSlime.class, NamespaceID.fromPool("minecraft", "slime"), MobSlime::new, "guidebook.section.mob.slime.name");
+        FACTORY_GHAST = addMapping(MobGhast.class, NamespaceID.fromPool("minecraft", "ghast"), MobGhast::new, "guidebook.section.mob.ghast.name");
+        FACTORY_SNOWMAN = addMapping(MobSnowman.class, NamespaceID.fromPool("minecraft", "snowman"), MobSnowman::new, "guidebook.section.mob.snowman.name");
 
-    public static @Nullable NamespaceID idForClass(Class<? extends Entity> entityClass) {
-        return classToIdMap.get(entityClass);
+        // Passive
+        FACTORY_SCORPION = addMapping(MobScorpion.class, NamespaceID.fromPool("minecraft", "scorpion"), MobScorpion::new);
+        FACTORY_PIG = addMapping(MobPig.class, NamespaceID.fromPool("minecraft", "pig"), MobPig::new, "guidebook.section.mob.pig.name");
+        FACTORY_SHEEP = addMapping(MobSheep.class, NamespaceID.fromPool("minecraft", "sheep"), MobSheep::new, "guidebook.section.mob.sheep.name");
+        FACTORY_COW = addMapping(MobCow.class, NamespaceID.fromPool("minecraft", "cow"), MobCow::new, "guidebook.section.mob.cow.name");
+        FACTORY_CHICKEN = addMapping(MobChicken.class, NamespaceID.fromPool("minecraft", "chicken"), MobChicken::new, "guidebook.section.mob.chicken.name");
+        FACTORY_SQUID = addMapping(MobSquid.class, NamespaceID.fromPool("minecraft", "squid"), MobSquid::new, "guidebook.section.mob.squid.name");
+        FACTORY_WOLF = addMapping(MobWolf.class, NamespaceID.fromPool("minecraft", "wolf"), MobWolf::new, "guidebook.section.mob.wolf.name");
+        FACTORY_FIREFLY_CLUSTER = addMapping(MobFireflyCluster.class, NamespaceID.fromPool("minecraft", "firefly_cluster"), MobFireflyCluster::new, "guidebook.section.mob.firefly_cluster.name");
+        FACTORY_BUTTERFLY = addMapping(MobButterfly.class, NamespaceID.fromPool("minecraft", "butterfly"), MobButterfly::new, "guidebook.section.mob.butterfly.name");
+        FACTORY_DEER = addMapping(MobDeer.class, NamespaceID.fromPool("minecraft", "deer"), MobDeer::new, "guidebook.section.mob.deer.name");
     }
 
-    public static @Nullable Class<? extends Entity> classForNumericId(int id) {
-        return numericIdToClassMap.get(id);
+    public <T extends Entity> @NotNull EntityFactory<T> addMapping(@NotNull Class<T> entityClass, @NotNull NamespaceID namespaceID, @NotNull EntityFactory<T> factory) {
+        return addMapping(entityClass, namespaceID, factory, null);
     }
 
-    public static @Nullable String nameKeyForClass(Class<? extends Entity> entityClass) {
-        return classToNameKeyMap.get(entityClass);
-    }
+    public <T extends Entity> @NotNull EntityFactory<T> addMapping(@NotNull Class<T> entityClass, @NotNull NamespaceID namespaceID, @NotNull EntityFactory<T> factory, @Nullable String nameKey) {
+        if (classToEntryMap.containsKey(entityClass)) {
+            throw new IllegalArgumentException("EntityDispatcher already contains an assignment for class " + entityClass.getSimpleName() + " with namespace " + classToEntryMap.get(entityClass).namespaceID + "!");
+        }
+        final @NotNull NamespaceID unpooledNamespaceID = namespaceID.copyUnpooled();
 
-    public static int numericIdForClass(Class<? extends Entity> entityClass) {
-        return classToNumericIdMap.getOrDefault(entityClass, -1);
+        int numericId = mappingCount++;
+        EntityDispatcherEntry<T> entry = new EntityDispatcherEntry<>(namespaceID, numericId, entityClass, factory, nameKey);
+        entries.add(entry);
+        idToEntryMap.put(entry.namespaceID, entry);
+        stringIdToEntryMap.put(entry.stringID, entry);
+        classToEntryMap.put(entry.entityClass, entry);
+        numericIdToEntryMap.put(entry.numericID, entry);
+
+        return factory;
     }
 
-    public static void setNumericIds(final @NotNull Int2ObjectMap<String> mapping) {
-        numericIdToClassMap.clear();
+    public void setNumericIds(final @NotNull Int2ObjectMap<String> mapping) {
+        numericIdToEntryMap.clear();
         numericIdToStringIdMap.clear();
-        classToNumericIdMap.clear();
         for (final Int2ObjectMap.Entry<String> entry : mapping.int2ObjectEntrySet()) {
-            final Class<? extends Entity> entityClass = classForId(entry.getValue());
-            if (entityClass == null) {
-                LOGGER.error("Could not find entityClass assigned to namespace id {}! Skipping!", entry.getValue());
+            EntityDispatcherEntry<?> e = stringIdToEntryMap.get(entry.getValue());
+            if (e == null) {
+                LOGGER.error("Could not find entity dispatcher entry assigned to namespace id {}! Skipping!", entry.getValue());
                 continue;
             }
 
-            numericIdToClassMap.put(entry.getIntKey(), entityClass);
+            e.updateID(entry.getIntKey());
+            numericIdToEntryMap.put(entry.getIntKey(), e);
             numericIdToStringIdMap.put(entry.getIntKey(), entry.getValue());
-            classToNumericIdMap.put(entityClass, entry.getIntKey());
 
             if (entry.getIntKey() >= mappingCount) {
                 mappingCount = entry.getIntKey() + 1;
@@ -111,45 +182,67 @@ public final class EntityDispatcher
         }
     }
 
-    public static Int2ObjectMap<String> getEntityIds() {
+    public @Nullable EntityDispatcher.EntityDispatcherEntry<?> entryForId(@NotNull NamespaceID id) {
+        return idToEntryMap.get(id);
+    }
+
+    public @Nullable EntityDispatcher.EntityDispatcherEntry<?> entryForId(@NotNull String id) {
+        return stringIdToEntryMap.get(id);
+    }
+
+    public @Nullable EntityDispatcher.EntityDispatcherEntry<?> entryForNumericId(int id) {
+        return numericIdToEntryMap.get(id);
+    }
+
+    public @Nullable <T extends Entity> EntityDispatcher.EntityDispatcherEntry<T> entryForClass(@Nullable Class<T> entityClass) {
+        return (EntityDispatcherEntry<T>) classToEntryMap.get(entityClass);
+    }
+
+    public @NotNull Int2ObjectMap<String> getEntityIds() {
         return numericIdToStringIdMap;
     }
 
-    public static @Nullable Entity createEntityInWorld(@Nullable final String id, @NotNull final World world)
+    public @Nullable Entity createEntityInWorld(@Nullable final String id, @NotNull final World world)
     {
         if (id == null) return null;
+        EntityDispatcherEntry<?> entry;
         if (Legacy.isLegacyKey(id)) { // Handle entity creation via legacy id
-            return createEntityInWorld(Legacy.getClassFromEncodeID(id), world);
-        } else {
-            Class<? extends Entity> entityClass = classForId(id);
-            if (entityClass == null) {
+            entry = entryForClass(Legacy.getClassFromEncodeID(id));
+            if (entry != null) {
+                return entry.factory.createEntity(world);
+            } else {
                 LOGGER.warn("EntityDispatcher could not find entity class for id '{}'!", id);
                 return null;
             }
-            return createEntityInWorld(entityClass, world);
+        } else {
+            entry = entryForId(id);
         }
+        if (entry != null) {
+            return entry.factory.createEntity(world);
+        }
+        LOGGER.warn("EntityDispatcher could not find entity class for id '{}'!", id);
+        return null;
     }
 
-    public static @Nullable Entity createEntityInWorld(@NotNull final NamespaceID id, @NotNull final World world) {
-        return createEntityInWorld(classForId(id), world);
+    public @Nullable Entity createEntityInWorld(@NotNull final NamespaceID id, @NotNull final World world) {
+        EntityDispatcherEntry<?> entry = entryForId(id);
+        if (entry != null) {
+            return entry.factory.createEntity(world);
+        }
+        LOGGER.warn("EntityDispatcher could not find entity class for id '{}'!", id);
+        return null;
     }
 
-    public static @Nullable Entity createEntityInWorld(@Nullable final Class<? extends Entity> clazz, @NotNull final World world) {
-        Entity entity = null;
-        try {
-            if(clazz != null) {
-                entity = clazz.getConstructor(World.class).newInstance(world);
-            } else {
-                return null;
-            }
-        }
-        catch(Exception exception) {
-            LOGGER.error("Failed to instance for class '{}'!", clazz.getSimpleName(), exception);
+    public @Nullable <T extends Entity> T createEntityInWorld(@NotNull Class<T> entityClass, @NotNull final World world) {
+        EntityDispatcherEntry<T> entry = entryForClass(entityClass);
+        if (entry != null) {
+            return entry.factory.createEntity(world);
         }
-        return entity;
+        LOGGER.warn("EntityDispatcher could not find entity class for class '{}'!", entityClass.getSimpleName());
+        return null;
     }
 
-    public static Entity createEntityFromNBT(CompoundTag compoundTag, World world)
+    public @Nullable Entity createEntityFromNBT(@NotNull CompoundTag compoundTag, @NotNull World world)
     {
         String id = compoundTag.getStringOrDefault("id", "UNKNOWN");
         Entity entity = createEntityInWorld(id, world);
@@ -162,76 +255,39 @@ public final class EntityDispatcher
         return entity;
     }
 
-    public static @Nullable Entity createEntity(int id, World world)
+    public @Nullable Entity createEntity(int id, @NotNull World world)
     {
-        @Nullable Entity entity = null;
-        try
-        {
-            Class<? extends Entity> clazz = classForNumericId(id);
-            if(clazz != null) {
-                entity = clazz.getConstructor(new Class[] {World.class}).newInstance(world);
-            } else {
-                LOGGER.error("No entity class assign to id {}!", id);
-            }
+        EntityDispatcherEntry<?> entry = entryForNumericId(id);
+        if(entry != null) {
+            return entry.factory.createEntity(world);
         }
-        catch(Exception exception)
-        {
-            LOGGER.error("Failed to instance entity id '{}'!", id, exception);
-        }
-        return entity;
+        LOGGER.error("No entity class assign to id {}!", id);
+        return null;
     }
 
-    private static boolean hasInit = false;
-    public static void init() {
-        if (hasInit) return;
-        hasInit = true;
 
-        // Misc
-        addMapping(EntityItem.class, NamespaceID.fromPool("minecraft", "item"));
-        addMapping(EntityPainting.class, NamespaceID.fromPool("minecraft", "painting"));
-        addMapping(EntityLightning.class, NamespaceID.fromPool("minecraft", "lightning"));
-        addMapping(EntityFallingBlock.class, NamespaceID.fromPool("minecraft", "falling_block"));
-        addMapping(EntityMinecart.class, NamespaceID.fromPool("minecraft", "minecart"));
-        addMapping(EntityBoat.class, NamespaceID.fromPool("minecraft", "boat"));
-        addMapping(EntityPrimedTNT.class, NamespaceID.fromPool("minecraft", "primed_tnt"));
+    public static void init() {}
 
-        // Projectiles
-        addMapping(ProjectilePebble.class, NamespaceID.fromPool("minecraft", "pebble"));
-        addMapping(ProjectileEgg.class, NamespaceID.fromPool("minecraft", "egg"));
-        addMapping(ProjectileArrow.class, NamespaceID.fromPool("minecraft", "arrow"));
-        addMapping(ProjectileArrowGolden.class, NamespaceID.fromPool("minecraft", "arrow_golden"));
-        addMapping(ProjectileArrowPurple.class, NamespaceID.fromPool("minecraft", "arrow_purple"));
-        addMapping(ProjectileSnowball.class, NamespaceID.fromPool("minecraft", "snowball"));
-        addMapping(ProjectileFireball.class, NamespaceID.fromPool("minecraft", "fireball"));
-        addMapping(ProjectileCannonball.class, NamespaceID.fromPool("minecraft", "cannonball"));
-
-        addMapping(Mob.class, NamespaceID.fromPool("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
-        addMapping(MobHuman.class, NamespaceID.fromPool("minecraft", "human"));
-        addMapping(Player.class, NamespaceID.fromPool("minecraft", "player"));
+    public static class EntityDispatcherEntry<T extends Entity> {
+        public final @NotNull NamespaceID namespaceID;
+        public final @NotNull String stringID;
+        public int numericID;
+        public final @NotNull EntityFactory<T> factory;
+        public final @NotNull Class<T> entityClass;
+        public final @Nullable String nameKey;
 
-        // Hostile
-        addMapping(MobZombie.class, NamespaceID.fromPool("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
-        addMapping(MobZombieArmored.class, NamespaceID.fromPool("minecraft", "zombie_armored"), "guidebook.section.mob.armored_zombie.name");
-        addMapping(MobZombiePig.class, NamespaceID.fromPool("minecraft", "zombie_pigman"), "guidebook.section.mob.zombie_pigman.name");
-        addMapping(MobCreeper.class, NamespaceID.fromPool("minecraft", "creeper"), "guidebook.section.mob.creeper.name");
-        addMapping(MobSkeleton.class, NamespaceID.fromPool("minecraft", "skeleton"), "guidebook.section.mob.skeleton.name");
-        addMapping(MobSpider.class, NamespaceID.fromPool("minecraft", "spider"), "guidebook.section.mob.spider.name");
-        addMapping(MobGiant.class, NamespaceID.fromPool("minecraft", "giant"));
-        addMapping(MobSlime.class, NamespaceID.fromPool("minecraft", "slime"), "guidebook.section.mob.slime.name");
-        addMapping(MobGhast.class, NamespaceID.fromPool("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
-        addMapping(MobSnowman.class, NamespaceID.fromPool("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
+        public EntityDispatcherEntry(@NotNull NamespaceID namespaceID, int numericID, @NotNull Class<T> entityClass, @NotNull EntityFactory<T> factory, @Nullable String nameKey) {
+            this.namespaceID = namespaceID;
+            this.stringID = namespaceID.toString();
+            this.numericID = numericID;
+            this.factory = factory;
+            this.entityClass = entityClass;
+            this.nameKey = nameKey;
+        }
 
-        // Passive
-        addMapping(MobScorpion.class, NamespaceID.fromPool("minecraft", "scorpion"));
-        addMapping(MobPig.class, NamespaceID.fromPool("minecraft", "pig"), "guidebook.section.mob.pig.name");
-        addMapping(MobSheep.class, NamespaceID.fromPool("minecraft", "sheep"), "guidebook.section.mob.sheep.name");
-        addMapping(MobCow.class, NamespaceID.fromPool("minecraft", "cow"), "guidebook.section.mob.cow.name");
-        addMapping(MobChicken.class, NamespaceID.fromPool("minecraft", "chicken"), "guidebook.section.mob.chicken.name");
-        addMapping(MobSquid.class, NamespaceID.fromPool("minecraft", "squid"), "guidebook.section.mob.squid.name");
-        addMapping(MobWolf.class, NamespaceID.fromPool("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
-        addMapping(MobFireflyCluster.class, NamespaceID.fromPool("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
-        addMapping(MobButterfly.class, NamespaceID.fromPool("minecraft", "butterfly"), "guidebook.section.mob.butterfly.name");
-        addMapping(MobDeer.class, NamespaceID.fromPool("minecraft", "deer"), "guidebook.section.mob.deer.name");
+        public void updateID(int newNumericID) {
+            this.numericID = newNumericID;
+        }
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index b6235fd3e..26aada370 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.entity;
 
+import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.sound.SoundCategory;
@@ -39,6 +40,12 @@ public class EntityLightning extends Entity
         {
             world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, x, y, z, "ambient.weather.thunder", 10000F, 0.8F + random.nextFloat() * 0.2F);
             world.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, x, y, z, "random.explode", 2.0F, 0.5F + random.nextFloat() * 0.2F);
+            for (int i = 0; i < world.loadedEntityList.size(); i++) {
+                Entity e = world.loadedEntityList.get(i);
+                if (e instanceof MobWolf) {
+                    ((MobWolf) e).whine();
+                }
+            }
         }
         life--;
         if(life < 0)
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index c4de84b39..eebfdd8fe 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -60,7 +60,7 @@ public abstract class Mob extends Entity
     public int prevHealth;
     public int bonusHealth;
     public int prevBonusHealth;
-    private int livingSoundTime;
+    protected int livingSoundTime;
     public int hurtTime;
     public int maxHurtTime;
     public float attackedAtYaw;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index 3d5829f10..1c1cb3b3e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -10,7 +10,6 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.helper.UUIDHelper;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.pathfinder.Path;
@@ -262,19 +261,26 @@ public class MobWolf
         }
         if(random.nextInt(3) == 0)
         {
-            if(isWolfTamed() && getHealth() < getMaxHealth()/2)
+            if((isWolfTamed() && getHealth() < getMaxHealth()/2))
             {
                 return "mob.wolf.whine";
             } else
             {
                 return "mob.wolf.panting";
             }
-        } else
-        {
+        } else {
             return "mob.wolf.bark";
         }
     }
 
+    public void whine() {
+        if(!world.isClientSide)
+        {
+            livingSoundTime = -getAmbientSoundInterval();
+            world.playSoundAtEntity(null, this, "mob.wolf.whine", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
+        }
+    }
+
     @Override
 	protected String getHurtSound()
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/factories/EntityDontUseFactory.java b/game/core/src/main/java/net/minecraft/core/entity/factories/EntityDontUseFactory.java
new file mode 100644
index 000000000..5bc69fda8
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/factories/EntityDontUseFactory.java
@@ -0,0 +1,12 @@
+package net.minecraft.core.entity.factories;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+public class EntityDontUseFactory<T extends Entity> implements EntityFactory<T> {
+    @Override
+    public T createEntity(@NotNull World world) {
+        throw new UnsupportedOperationException();
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/factories/EntityFactory.java b/game/core/src/main/java/net/minecraft/core/entity/factories/EntityFactory.java
new file mode 100644
index 000000000..1e35c8372
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/factories/EntityFactory.java
@@ -0,0 +1,9 @@
+package net.minecraft.core.entity.factories;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+public interface EntityFactory<T extends Entity> {
+    T createEntity(@NotNull World world);
+}
